timestepratio=0.1;
testfunction=1;
method=3; % 1: esplicito; 2: implicito diretto; 3: implicito iterativo
xmin=0; xmax=1; Nx=50;
x=linspace(xmin,xmax,Nx)';
dx=x(2)-x(1);
dt0=dx^2/2;
dt=dt0/timestepratio;
tmin=0; tmax=5;
Nt=round((tmax-tmin)/dt);
t=linspace(tmin,tmax,Nt)';
dt=t(2)-t(1);
fprintf('dx: %f - dt: %f - dt/(dx^2/2): %f\n',...
    dt,dx,dt/(dx^2/2))
fprintf('Nx: %i - Nt: %i\n',Nx,Nt)

U=zeros(Nx,Nt);
Utrue=zeros(Nx,Nt);
U(:,1)=mysol(x,t(1),testfunction);
Utrue(:,1)=U(:,1);
tic
for nt=2:Nt
    U(:,nt)=heateq2(U(:,nt-1),x,t(nt),dt,method,testfunction);
    Utrue(:,nt)=mysol(x,t(nt),testfunction);
end
tim=toc;
fprintf('Tempo=%f s\n',tim)
error=U-Utrue;
errort=max(abs(error));

figure(1)
clf;
set(gcf,'Name','Eq. calore')
subplot(1,2,1)
plot(x,U(:,Nt))
xlabel('x')
ylabel('u')
title(['Soluzione a t=' num2str(t(Nt))])
subplot(1,2,2)
surf(t,x,U)
xlabel('t')
ylabel('x')
zlabel('u')
shading interp
title(['Soluzione a t=' num2str(t(Nt))])

figure(2)
clf;
set(gcf,'Name','Eq. calore - Errore')
subplot(1,2,1)
plot(x,error(:,Nt))
xlabel('x')
ylabel('u')
title(['Errore a t=' num2str(t(Nt))])
subplot(1,2,2)
surf(t,x,error)
xlabel('t')
ylabel('x')
zlabel('u')
shading interp
title('Errore')

figure(3)
plot(t,errort)
xlabel('t')
ylabel('max(error)')

























